# Java Log Log4j2 demo

可以直接在`application.properties` 配置。
也可以使用`log4j2.xml` 配置,但需要在`application.properties` 指定配置文件
`logging.config=classpath:log4j2.xml`

## 引入依赖
```xml
<!--Log4j2相关的依赖包-->
<dependency>
  <groupId>org.apache.logging.log4j</groupId>
  <artifactId>log4j-api</artifactId>
  <version>2.17.2</version>
</dependency>
<dependency>
    <groupId>org.apache.logging.log4j</groupId>
    <artifactId>log4j-core</artifactId>
    <version>2.17.2</version>
</dependency>
```

## 使用Log4j2 API
Spring 默认引入了`JCL` 和`SLF4j` 两个门面，因此如果只测试`Log4j2` 就需要排除`spring-jcl` 和`slf4j-api`,
但由于Spring Boot项目内部有使用`JCL`门面的日志输出，因此需要再额外引入`JCL`的门面包`commons-logging` 


```xml
<!--添加jcl 依赖-->
<dependency>
    <groupId>commons-logging</groupId>
    <artifactId>commons-logging</artifactId>
    <version>1.2</version>
</dependency>
```

只是这样会原本使用JCL输出的日志将无法输出，因为没有具体的JCL实现了。这个问题后面解决。
> `spring-jcl` 是Spring自己实现的 `jcl` 重定向到`slf4j`的包。
日志输出：
```log
2023-10-26 15:58:20.652 TRACE 46532 --- [           main] c.f.LogLog4j2Tests                       : 这是trace日志...
2023-10-26 15:58:20.654 DEBUG 46532 --- [           main] c.f.LogLog4j2Tests                       : 这是debug日志...
2023-10-26 15:58:20.655  INFO 46532 --- [           main] c.f.LogLog4j2Tests                       : 这是info日志...
2023-10-26 15:58:20.655  WARN 46532 --- [           main] c.f.LogLog4j2Tests                       : 这是warn日志...
2023-10-26 15:58:20.655 ERROR 46532 --- [           main] c.f.LogLog4j2Tests                       : 这是error日志...
2023-10-26 15:58:20.656  INFO 46532 --- [           main] c.f.LogLog4j2Tests                       : 这是info日志...test
2023-10-26 15:58:20.657  INFO 46532 --- [           main] c.f.LogLog4j2Tests                       : public class org.apache.logging.log4j.core.Logger
```
