# Java Log Logback demo

配置文件为：`logback.xml`

## 引入依赖
```xml
<dependency>
    <groupId>ch.qos.logback</groupId>
    <artifactId>logback-classic</artifactId>
    <version>1.2.11</version>
</dependency>
```
`logback-classic` 是包含`slf4j`门面和`logback`给`slf4j`门面的实现，因此引入这个一个包就可以了。

> 注： JDK8 只能使用1.3及以下版本，1.4以上版要求JDK11，详情参考：
https://logback.qos.ch/news.html

Spring 默认引入了`JCL` 和`SLF4j` 两个门面，因此如果只测试`SLF4j` 就需要排除`spring-jcl`,
但由于Spring Boot项目内部有使用`JCL`门面的日志输出，因此需要再额外引入`JCL`的门面包`commons-logging`
```xml
<!--添加jcl 依赖-->
<dependency>
    <groupId>commons-logging</groupId>
    <artifactId>commons-logging</artifactId>
    <version>1.2</version>
</dependency>
```

只是这样会原本使用`JCL`输出的日志将无法输出，因为没有具体的`JCL`实现了。这个问题后面解决。
> `spring-jcl` 是Spring自己实现的 `jcl` 重定向到`slf4j`的包。


日志输出：
```log
16:32:07.122 [main] TRACE com.feiyizhan.LogBackTests - 这是trace日志...
16:32:07.124 [main] DEBUG com.feiyizhan.LogBackTests - 这是debug日志...
16:32:07.124 [main] INFO  com.feiyizhan.LogBackTests - 这是info日志...
16:32:07.124 [main] WARN  com.feiyizhan.LogBackTests - 这是warn日志...
16:32:07.124 [main] ERROR com.feiyizhan.LogBackTests - 这是error日志...
16:32:07.124 [main] INFO  com.feiyizhan.LogBackTests - 这是info日志...test
16:32:07.126 [main] INFO  com.feiyizhan.LogBackTests - public final class ch.qos.logback.classic.Logger
```