# Java Log SLF4j demo
测试只有slf4j-api 接口包，没有具体实现包的场景

## 引入依赖
```xml
<!--添加Slfj 依赖-->
<dependency>
  <groupId>org.slf4j</groupId>
  <artifactId>slf4j-api</artifactId>
  <version>${slf4j.version}</version>
</dependency>

```

Spring 默认引入了`JCL` 和`SLF4j` 两个门面，因此如果只测试`SLF4j` 就需要排除`spring-jcl`,
但由于Spring Boot项目内部有使用`JCL`门面的日志输出，因此需要再额外引入`JCL`的门面包`commons-logging`
```xml
<!--添加jcl 依赖-->
<dependency>
    <groupId>commons-logging</groupId>
    <artifactId>commons-logging</artifactId>
    <version>1.2</version>
</dependency>
```

只是这样会原本使用`JCL`输出的日志将无法输出，因为没有具体的`JCL`实现了。这个问题后面解决。
> `spring-jcl` 是Spring自己实现的 `jcl` 重定向到`slf4j`的包。


输出结果
```log
SLF4J: No SLF4J providers were found.
SLF4J: Defaulting to no-operation (NOP) logger implementation
SLF4J: See https://www.slf4j.org/codes.html#noProviders for further details.
```
