package com.feiyizhan;

import org.junit.jupiter.api.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.boot.test.context.SpringBootTest;


/**
 * SLF4J 的demo
 * @author 徐明龙 XuMingLong 2023-09-13
 */
@SpringBootTest
class Slf4jTests {

	final Logger logger = LoggerFactory.getLogger(Slf4jTests.class);

	/**
	 *  测试只有SLFJ API依赖，没有具体实现的场景
	 * @author 徐明龙 XuMingLong 2023-09-13
	 * @return void
	 */
	@Test
	void test_default_log() {
		logger.trace("这是trace日志..."); //跟踪轨迹
		logger.debug("这是debug日志..."); //调试
		//SpringBoot默认给我们使用的是info级别的，没有指定级别的就用SpringBoot默认规定的级别（root级别）
		logger.info("这是info日志...");
		logger.warn("这是warn日志...");
		logger.error("这是error日志...");
		logger.info("这是info日志...{}","test");
		logger.info(logger.getClass().toGenericString());

	}

}
