# slf4j multi binding demo 
测试提供多个binding的demo

> 注意 `logging.config=classpath:logging.properties`  这个配置同时对`Logback` 和`Jul`生效，但由于它们配置文件是不同的，因此不能时配置这两个日志

测试结果：
```
2023-10-27 13:34:48 DEBUG (com.feiyizhan.LogJclTests:21) - LogJclTests 这是debug日志...
2023-10-27 13:34:48  INFO (com.feiyizhan.LogJclTests:23) - LogJclTests 这是info日志...
2023-10-27 13:34:48  WARN (com.feiyizhan.LogJclTests:24) - LogJclTests 这是warn日志...
2023-10-27 13:34:48 ERROR (com.feiyizhan.LogJclTests:25) - LogJclTests 这是error日志...
2023-10-27 13:34:48  INFO (com.feiyizhan.LogJclTests:26) - LogJclTests public class org.apache.commons.logging.impl.Log4JLogger
十月 27, 2023 1:34:48 下午 com.feiyizhan.LogJulTests printLog
信息: LogJulTests 这是info日志...
十月 27, 2023 1:34:48 下午 com.feiyizhan.LogJulTests printLog
信息: LogJulTests public class java.util.logging.Logger
2023-10-27 13:34:48 DEBUG (com.feiyizhan.LogLog4jTests:21) - LogLog4jTests 这是debug日志...
2023-10-27 13:34:48  INFO (com.feiyizhan.LogLog4jTests:23) - LogLog4jTests 这是info日志...
2023-10-27 13:34:48  WARN (com.feiyizhan.LogLog4jTests:24) - LogLog4jTests 这是warn日志...
2023-10-27 13:34:48 ERROR (com.feiyizhan.LogLog4jTests:25) - LogLog4jTests 这是error日志...
2023-10-27 13:34:48  INFO (com.feiyizhan.LogLog4jTests:26) - LogLog4jTests public class org.apache.log4j.Logger
SLF4J: Class path contains multiple SLF4J bindings.
SLF4J: Found binding in [jar:file:/D:/repository/ch/qos/logback/logback-classic/1.2.11/logback-classic-1.2.11.jar!/org/slf4j/impl/StaticLoggerBinder.class]
SLF4J: Found binding in [jar:file:/D:/repository/org/slf4j/slf4j-simple/1.7.36/slf4j-simple-1.7.36.jar!/org/slf4j/impl/StaticLoggerBinder.class]
SLF4J: Found binding in [jar:file:/D:/repository/org/slf4j/slf4j-jdk14/1.7.36/slf4j-jdk14-1.7.36.jar!/org/slf4j/impl/StaticLoggerBinder.class]
SLF4J: Found binding in [jar:file:/D:/repository/org/slf4j/slf4j-jcl/1.7.36/slf4j-jcl-1.7.36.jar!/org/slf4j/impl/StaticLoggerBinder.class]
SLF4J: Found binding in [jar:file:/D:/repository/org/slf4j/slf4j-reload4j/1.7.36/slf4j-reload4j-1.7.36.jar!/org/slf4j/impl/StaticLoggerBinder.class]
SLF4J: Found binding in [jar:file:/D:/repository/org/apache/logging/log4j/log4j-slf4j-impl/2.21.1/log4j-slf4j-impl-2.21.1.jar!/org/slf4j/impl/StaticLoggerBinder.class]
SLF4J: See http://www.slf4j.org/codes.html#multiple_bindings for an explanation.
SLF4J: Actual binding is of type [ch.qos.logback.classic.util.ContextSelectorStaticBinder]
13:34:48.953 [main] INFO  com.feiyizhan.LogBackTests - LogBackTests 这是info日志...
13:34:48.958 [main] WARN  com.feiyizhan.LogBackTests - LogBackTests 这是warn日志...
13:34:48.958 [main] ERROR com.feiyizhan.LogBackTests - LogBackTests 这是error日志...
13:34:48.958 [main] INFO  com.feiyizhan.LogBackTests - LogBackTests 这是info日志...test
13:34:48.962 [main] INFO  com.feiyizhan.LogBackTests - LogBackTests public final class ch.qos.logback.classic.Logger
13:34:48.962 [main] INFO  com.feiyizhan.LogLog4j2Tests - 这是info日志...
13:34:48.962 [main] WARN  com.feiyizhan.LogLog4j2Tests - 这是warn日志...
13:34:48.962 [main] ERROR com.feiyizhan.LogLog4j2Tests - 这是error日志...
13:34:48.963 [main] INFO  com.feiyizhan.LogLog4j2Tests - 这是info日志...test
13:34:48.963 [main] INFO  com.feiyizhan.LogLog4j2Tests - public final class ch.qos.logback.classic.Logger
13:34:48.963 [main] INFO  com.feiyizhan.LogSlf4jSimpleTests - LogSlf4jSimpleTests 这是info日志...
13:34:48.964 [main] WARN  com.feiyizhan.LogSlf4jSimpleTests - LogSlf4jSimpleTests 这是warn日志...
13:34:48.964 [main] ERROR com.feiyizhan.LogSlf4jSimpleTests - LogSlf4jSimpleTests 这是error日志...
13:34:48.964 [main] INFO  com.feiyizhan.LogSlf4jSimpleTests - LogSlf4jSimpleTests 这是info日志...test
13:34:48.964 [main] INFO  com.feiyizhan.LogSlf4jSimpleTests - LogSlf4jSimpleTests public final class ch.qos.logback.classic.Logger
```

最终使用的是的加载的第一个`StaticLoggerBinder``logback` 来输出日志。

slfj的常用的binding包有
```xml
<!-- SLF4j binding logback-->
<dependency>
  <groupId>ch.qos.logback</groupId>
  <artifactId>logback-classic</artifactId>
  <version>1.2.11</version>
</dependency>

<!--SLF4j simple binding-->
<dependency>
    <groupId>org.slf4j</groupId>
    <artifactId>slf4j-simple</artifactId>
    <version>${slf4j.version}</version>
</dependency>

 <!--SLF4j binding jul -->
<dependency>
    <groupId>org.slf4j</groupId>
    <artifactId>slf4j-jdk14</artifactId>
    <version>${slf4j.version}</version>
</dependency>

<!-- SLF4j binding jcl  -->
<dependency>
    <groupId>org.slf4j</groupId>
    <artifactId>slf4j-jcl</artifactId>
    <version>${slf4j.version}</version>
    <exclusions>
      <exclusion>
        <artifactId>commons-logging</artifactId>
        <groupId>commons-logging</groupId>
      </exclusion>
    </exclusions>
</dependency>

<!-- SLF4j binding Log4j (已弃用）-->
<dependency>
    <groupId>org.slf4j</groupId>
    <artifactId>slf4j-log4j12</artifactId>
    <version>${slf4j.version}</version>
</dependency>

<!-- SLF4j binding Log4j -->
<dependency>
    <groupId>org.slf4j</groupId>
    <artifactId>slf4j-reload4j</artifactId>
    <version>${slf4j.version}</version>
</dependency>

<!-- SLF4j binding Log4j2-->
<dependency>
    <groupId>org.apache.logging.log4j</groupId>
    <artifactId>log4j-slf4j-impl</artifactId>
    <version>${log4j2.version}</version>
</dependency>
```

其中`slf4j-log4j12` 已经被`slf4j-reload4j` 替代，引入`slf4j-log4j12` 会被自动替换成`slf4j-reload4j` ，因此建议直接使用`slf4j-reload4j` 
具体看官网 https://www.slf4j.org/manual.html

