# Java Log SLF4j simple demo
测试使用SLF4j-simple 输出日志的

Spring Boot环境下，简单配置`slf4j-simple` 方式就是在`application.properties` 增加`logging.` 前缀的配置
例如
`logging.level.root = info`
更详细的配置可以增加`simplelogger.properties` 配置文件来配置
默认的日志输出格式相当于`log4j`的 `"%r [%t] %level %logger - %m%n"`

## 引入对应依赖
```xml
<!--添加Slfj 依赖-->
<dependency>
  <groupId>org.slf4j</groupId>
  <artifactId>slf4j-api</artifactId>
  <version>${slf4j.version}</version>
</dependency>

<dependency>
    <groupId>org.slf4j</groupId>
    <artifactId>slf4j-simple</artifactId>
    <version>${slf4j.version}</version>
</dependency>
```

Spring 默认引入了`JCL` 和`SLF4j` 两个门面，因此如果只测试`SLF4j` 就需要排除`spring-jcl`,
但由于Spring Boot项目内部有使用`JCL`门面的日志输出，因此需要再额外引入`JCL`的门面包`commons-logging`
```xml
<!--添加jcl 依赖-->
<dependency>
    <groupId>commons-logging</groupId>
    <artifactId>commons-logging</artifactId>
    <version>1.2</version>
</dependency>
```

只是这样会原本使用`JCL`输出的日志将无法输出，因为没有具体的`JCL`实现了。这个问题后面解决。
> `spring-jcl` 是Spring自己实现的 `jcl` 重定向到`slf4j`的包。



日志输出：
```log
2023-10-26 16:43:58.706 [main] DEBUG Slf4jSimpleTests - 这是debug日志...
2023-10-26 16:43:58.709 [main] INFO Slf4jSimpleTests - 这是info日志...
2023-10-26 16:43:58.710 [main] WARN Slf4jSimpleTests - 这是warn日志...
2023-10-26 16:43:58.710 [main] ERROR Slf4jSimpleTests - 这是error日志...
2023-10-26 16:43:58.710 [main] INFO Slf4jSimpleTests - 这是info日志...test
2023-10-26 16:43:58.710 [main] INFO Slf4jSimpleTests - public class org.slf4j.simple.SimpleLogger

```
